﻿using System;
using UnityEngine;

namespace Mod
{
    public class EnhancedLimb : MonoBehaviour
    {
        public GameObject arm;

        public void Initialize(Sprite sprite)
        {

            arm = new GameObject("enhanced limb");
            arm.transform.parent = gameObject.transform;
            arm.transform.localPosition = new Vector3(0f, 0f, transform.position.z);
            arm.transform.localRotation = Quaternion.identity;
            arm.transform.localScale = transform.localScale;

            SpriteRenderer armSprite = arm.AddComponent<SpriteRenderer>();
            armSprite.sprite = sprite;
            armSprite.sortingOrder = gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
            armSprite.sortingLayerName = gameObject.GetComponent<SpriteRenderer>().sortingLayerName;

            GetComponent<LimbBehaviour>().Person.Wince(5);
            GetComponent<LimbBehaviour>().Person.PainLevel += 0.25f;

            arm.transform.parent.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
            arm.transform.parent.gameObject.GetComponent<LimbBehaviour>().Color = Color.clear;

            var grip = GetComponent<LimbBehaviour>().GripBehaviour;
            grip.GripPosition = new Vector3(grip.GripPosition.x, grip.GripPosition.y, -100f);
        }

        public void Repair()
        {
            var limb = gameObject.GetComponent<LimbBehaviour>();
            var grip = GetComponent<LimbBehaviour>().GripBehaviour;
            grip.GripPosition = new Vector3(grip.GripPosition.x, grip.GripPosition.y, 0.45f);

            limb.Color = Color.white;
            ModAPI.CreateParticleEffect("MetalHit", limb.transform.position);
            ModAPI.CreateParticleEffect("BrokenElectronicsSpark", limb.transform.position);
            ModAPI.CreateParticleEffect("Vapor", limb.transform.position);
            limb.Person.Wince(50);
            limb.Person.PainLevel += 0.5f;

            Destroy(arm);
            Destroy(this);
        }
    }
}
