﻿using System;
using System.Collections;
using UnityEngine;

namespace Mod
{
    public class EnhancedLimbBehaviour : MonoBehaviour
    {
        public Type behaviour;

        AudioSource audio;
        public AudioClip clip;

        void Awake()
        {
            foreach (var hitboxes in GetComponents<Collider2D>()) { Destroy(hitboxes); }
            var a = gameObject.AddComponent<BoxCollider2D>();
            a.offset = new Vector2(0f, -0.01f);
            a.size = new Vector2(0.15f, 0.45f);

            clip = ModResources.elEquip;
        }

        void Use()
        {
            ModAPI.CreateParticleEffect("BrokenElectronicsSpark", transform.position);
        }

        public void OnCollisionEnter2D(Collision2D other) 
        {
            if (other.rigidbody.velocity.magnitude >= 1f && other.gameObject.GetComponent<GripBehaviour>() != null && other.gameObject.GetComponent<GripBehaviour>().GripPosition.z == 0.45f)
            {
                other.gameObject.GetComponent<GripBehaviour>().DropObject();
                OnGripped(other.gameObject.GetComponent<GripBehaviour>());
            }
        }

        public void OnGripped(GripBehaviour g)
        {
            GameObject soundObject = new GameObject();
            audio = soundObject.AddComponent<AudioSource>();
            audio.outputAudioMixerGroup = Global.main.SoundEffects;
            audio.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
            audio.PlayOneShot(clip);
            Destroy(soundObject, 1f);

            g.gameObject.AddComponent(behaviour);
        }
    }
}
