﻿using UnityEngine;

namespace Mod
{
    public class Mod : MonoBehaviour
    {

        private GameObject hand;

        private GameObject handGlow;

        public void Awake()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("t/Mark85Finale/Mark85InfinityGauntletLight.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= 10f)
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 12;
                var p = ModAPI.CreateParticleEffect("FuseBlown", new Vector2(hand.transform.position.x, hand.transform.position.y + 0.1f));
                p.gameObject.transform.localScale *= 3f;
                var m = p.GetComponent<ParticleSystem>().main;
                p.transform.position = gameObject.transform.position;
                p.transform.eulerAngles = gameObject.transform.eulerAngles;
                p.transform.eulerAngles += new Vector3(0, 0, 270);
                m.startColor = new Color(190f, 0f, 252f);

                var Colder = p.GetComponent<ParticleSystem>().main;
                Colder.startColor = new Color(190f, 0f, 252f);
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 8;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= 5f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0f, 0f, 1f);
            }
        }
    }
}