﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Mod
{
    public class hand : CanShoot
    {

        private GameObject Lazzer;
        private PhysicalBehaviour physicalBehaviour;
        private GameObject LazzerGlow;
        private Vector2 barrelPosition = new Vector2(0.3f, 0f);
        private Vector2 barrelDirection = new Vector2(0.1f, 0f);
        public bool upgraded = false;
        private LineRenderer beam;
        private LayerMask layers;
        private LayerMask bounds;
        private GameObject components;

        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];



        public void Start()
        {
            Lazzer = gameObject;
            physicalBehaviour = GetComponent<PhysicalBehaviour>();

            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");

            components = new GameObject("components", typeof(Optout));
            components.transform.SetParent(transform);
            components.transform.localPosition = new Vector3(0, 0);
            beam = components.AddComponent<LineRenderer>();
            beam.SetPositions(new[] { Vector3.zero, Vector3.right * 1000 });
            beam.useWorldSpace = false;
            beam.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            beam.sortingLayerName = "Background";
            beam.startColor = Color.red;
            beam.endColor = new Color(0, 255f, 255f);
            beam.widthMultiplier = 0.01f;
            beam.enabled = false;

        }
        private void Use()
        {
            Shoot();
        }


        public override void Shoot()
        {

                StartCoroutine(Fire());
        }




        private IEnumerator Fire()
        {
            const int iterations = 8;
            const float duration = 0.5f;

            const float interval = duration / iterations;

            beam.startColor = new Color(0, 255f, 255f);
            beam.endColor = new Color(0, 255f, 255f);
            beam.widthMultiplier = 0.01f;



            beam.enabled = true;
            for (int i = 0; i < iterations; i++)
            {
                var end = Physics2D.Raycast(BarrelPosition, BarrelDirection, 10000, bounds);
                var endPos = end.transform == null ? (Vector3)BarrelPosition + (Vector3)BarrelDirection * 10000 : (Vector3)end.point;
                var victimCount = Physics2D.LinecastNonAlloc(BarrelPosition, endPos, victimBuffer, layers);
                beam.SetPosition(1, components.transform.InverseTransformPoint(endPos));

                for (int n = 0; n < victimCount; n++)
                {
                    var victim = victimBuffer[n];
                    ExplosionCreator.CreatePulseExplosion(victim.point, 0.5f, 1, true);
                    victim.transform.SendMessage("Break", BarrelDirection, SendMessageOptions.DontRequireReceiver);
                    victim.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                    // phys.rigidbody.AddForceAtPosition(forward * DirectionalForce * phys.rigidbody.mass, hit.point, ForceMode2D.Impulse);
                }

                CameraShakeBehaviour.main.Shake(1, transform.position);
                physicalBehaviour.rigidbody.AddRelativeForce(new Vector2(-0.1f * transform.localScale.normalized.x, 0), ForceMode2D.Impulse);
                yield return new WaitForSeconds(interval);
            }
            beam.enabled = false;
            yield return new WaitForSeconds(2.8f);
        }

        public override Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }

        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }


    }
}
