using UnityEngine;

namespace BIM
{
    public class Mod
    {
        public static void Main()
        {
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Superior Iron Man [Costume inspired by Doctor Strange: in the multiverse of madness]", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "I believe we can. Just because someone stumbles and loses their way doesnt mean they're lost forever. We will see what kind of Doctor Strange you are.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb30.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("head.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("hair.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite1.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite1.sortingLayerName = "Bubbles";
									
									
									

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("middle.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 1f, 1f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("upperleg.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 1f, 1f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("lowerleg.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(1f, 1f, 1f, 0.25f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("upperleg.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 1f, 0.25f);
									legsprite3.sortingLayerName = "Default";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("lowerleg.png");
									legsprite4.sortingLayerName = "Default";
									legsprite4.color = new Color(1f, 1f, 1f, 0.25f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("upperarm.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("upperarm.png");
									armsprite2.sortingLayerName = "Default";
									armsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands = new GameObject();
									hands.transform.parent = hand1;
									hands.transform.localPosition = new Vector4(0f, 0f);
									hands.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite = hands.AddComponent<SpriteRenderer>();
									
									handsprite.sprite = ModAPI.LoadSprite("lowerarm.png");
									handsprite.sortingLayerName = "Bubbles";
									handsprite.color = new Color(1f, 1f, 1f, 1f);
									handsprite.material = ModAPI.FindMaterial("VeryBright");
									
									
								
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand2;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("lowerarm.png");
									handsprite1.sortingLayerName = "Decals";
									handsprite1.color = new Color(1f, 1f, 1f, 0.5f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("lower.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									 
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<superiorregen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Beam Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Vapor", new Vector2(arm1.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArm")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Vapor", new Vector2(arm1.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark85Finale/Mark85Finale.png");
						var flesh = ModAPI.LoadTexture("t/2.png");
						var bone = ModAPI.LoadTexture("t/3.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
						
					}
				}
			);
		}
	}
}