using UnityEngine;

namespace Mod
{
    public class BIM
    {
        public static void Main()
        {
			CategoryBuilder.Create("BBQ's IronMan", "Pshhhhhhhhhhhhhhhhhh(Flying)", ModAPI.LoadSprite("category.png"));
			CategoryBuilder.Create("BBQ's WarMachine","Congrats Cap, you are now criminal.", ModAPI.LoadSprite("category2.png"));
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "ARC Reactor",
                    DescriptionOverride = "Property of Stark Industries",
                    CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb2.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
						Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("t/Reactor.png" ,2.8f);

						var childObject = new GameObject("eye");
						childObject.transform.SetParent(Instance.transform);
						childObject.transform.localPosition = new Vector3(0f, 0f);
						childObject.transform.localScale = new Vector3(1f, 1f);
						var childSprite = childObject.AddComponent<SpriteRenderer>();
						childSprite.sprite = ModAPI.LoadSprite("t/Light.png" ,2.8f);
						childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						childObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

						childSprite.color = new Color(0f, 0.65f, 1f, 0.25f);


						Instance.FixColliders();

                    }
                }
            );
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 2 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Doth mother know you weareth her drapes?", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb3.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark2.png");
						var flesh = ModAPI.LoadTexture("t/Mark2.png");
						var bone = ModAPI.LoadTexture("t/Mark2.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Anthony Edward 'Tony' Stark  (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "I am Iron man.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb1.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
								
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/hair.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite.sortingLayerName = "Foreground";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/arc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.99f;
										body.BaseStrength *= 2f;
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Human");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;					
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/1.png");
						var flesh = ModAPI.LoadTexture("t/2.png");
						var bone = ModAPI.LoadTexture("t/3.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 3  (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Take this!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb6.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark3.png");
						var flesh = ModAPI.LoadTexture("t/Mark3.png");
						var bone = ModAPI.LoadTexture("t/Mark3.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 4 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Sometimes You Need A Little Bravado To Keep Things Interesting!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb4.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark4.png");
						var flesh = ModAPI.LoadTexture("t/Mark4.png");
						var bone = ModAPI.LoadTexture("t/Mark4.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 5 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Give me that Suitcase!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb5.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark5.png");
						var flesh = ModAPI.LoadTexture("t/Mark5.png");
						var bone = ModAPI.LoadTexture("t/Mark5.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 6 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "I already told you, I don't wanna join your Super Secret Boy Band!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb7.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/mark6arc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark6.png");
						var flesh = ModAPI.LoadTexture("t/Mark6.png");
						var bone = ModAPI.LoadTexture("t/Mark6.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 7 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "If we can't protect the earth, you can be damned sure we'll avenge it.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb8.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark7.png");
						var flesh = ModAPI.LoadTexture("t/Mark7.png");
						var bone = ModAPI.LoadTexture("t/Mark7.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 8 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "JARVIS, make a note. Remind me not to wake up in the morning ever again.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb9.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark8.png");
						var flesh = ModAPI.LoadTexture("t/Mark8.png");
						var bone = ModAPI.LoadTexture("t/Mark8.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 9 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Genius, Billionaire, Playboy, Philanthropist.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb12.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark9.png");
						var flesh = ModAPI.LoadTexture("t/Mark9.png");
						var bone = ModAPI.LoadTexture("t/Mark9.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 10 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "We need to be put in check. Whatever form that takes, I’m game.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb10.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark10.png");
						var flesh = ModAPI.LoadTexture("t/Mark10.png");
						var bone = ModAPI.LoadTexture("t/Mark10.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 1 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Give me a scotch. I'm starving.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb11.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
								
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark1.png");
						var flesh = ModAPI.LoadTexture("t/Mark1.png");
						var bone = ModAPI.LoadTexture("t/Mark1.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
					NameOverride = "Disabled Iron Man Helmet (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "J.A.R.V.I.S are you there?", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("HelmetThumb.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("t/helmet.png" ,1.65f); //get the SpriteRenderer and replace its sprite with a custom one
						Instance.FixColliders();
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
					NameOverride = "Disabled Iron Man Mark 4 Suit (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Dunce?", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("ArmorThumb.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("t/disable.png" ,1.65f); //get the SpriteRenderer and replace its sprite with a custom one
						Instance.FixColliders();
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 3f;
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 17 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Heartbreaker!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb13.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/heartbreakereye.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 0.65f, 0f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/heartbreakerarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 0.65f, 0f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();

									armsprite1.sprite = ModAPI.LoadSprite("t/heartbreakerupperarm.png");
									armsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();

									armsprite2.sprite = ModAPI.LoadSprite("t/heartbreakerupperarm.png");
									armsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<HeartbreakerUni>();
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.3f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1600f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark17.png");
						var flesh = ModAPI.LoadTexture("t/Mark17.png");
						var bone = ModAPI.LoadTexture("t/Mark17.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 21 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "If we can't protect the earth, you can be damned sure we'll avenge it.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb14.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark21.png");
						var flesh = ModAPI.LoadTexture("t/Mark21.png");
						var bone = ModAPI.LoadTexture("t/Mark21.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 20 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "I am Iron Man. The suit and I are one.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb15.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark20.png");
						var flesh = ModAPI.LoadTexture("t/Mark20.png");
						var bone = ModAPI.LoadTexture("t/Mark20.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 13 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Come on!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb16.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/13eye.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/13middle.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<HVSPUni>();
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark13.png");
						var flesh = ModAPI.LoadTexture("t/Mark13.png");
						var bone = ModAPI.LoadTexture("t/Mark13.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 33 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "You can take screwdriver or any toys,but it's something no one will ever take me.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb17.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/33arc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/33uparm.png");
									armsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/33uparm.png");
									armsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/33arm.png");
									handsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark33.png");
						var flesh = ModAPI.LoadTexture("t/Mark33.png");
						var bone = ModAPI.LoadTexture("t/Mark33.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 30 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "You can take screwdriver or any toys,but it's something no one will ever take me. I am Iron Man.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb18.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/33arc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/30uparm.png");
									armsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/30uparm.png");
									armsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/30arm.png");
									handsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									hand1.gameObject.AddComponent<Spike>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark30.png");
						var flesh = ModAPI.LoadTexture("t/Mark30.png");
						var bone = ModAPI.LoadTexture("t/Mark30.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 46 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "UNDEROOOOOS!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb19.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/46upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/46middle.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/46lowerleg.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/46lowerleg.png");
									legsprite4.sortingLayerName = "Foreground";
									legsprite4.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/46upperarm.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/46upperarm.png");
									armsprite2.sortingLayerName = "Default";
									armsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/46lowerarm.png");
									handsprite1.sortingLayerName = "Bubbles";
									handsprite1.color = new Color(0f, 1f, 1f, 0.05f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/46lowerarm.png");
									handsprite2.sortingLayerName = "Default";
									handsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									handsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/46lower.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark46.png");
						var flesh = ModAPI.LoadTexture("t/Mark46.png");
						var bone = ModAPI.LoadTexture("t/Mark46.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 47 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "If you're nothing without this suit, then you shouldn't have it.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb20.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/46upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/46middle.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/46lowerleg.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/46lowerleg.png");
									legsprite4.sortingLayerName = "Foreground";
									legsprite4.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/46upperarm.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/46upperarm.png");
									armsprite2.sortingLayerName = "Foreground";
									armsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/46lowerarm.png");
									handsprite1.sortingLayerName = "Bubbles";
									handsprite1.color = new Color(0f, 1f, 1f, 0.05f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/46lowerarm.png");
									handsprite2.sortingLayerName = "Foreground";
									handsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									handsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/46lower.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									hand1.gameObject.AddComponent<Spike>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark47.png");
						var flesh = ModAPI.LoadTexture("t/Mark47.png");
						var bone = ModAPI.LoadTexture("t/Mark47.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 43 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "JARVIS, Send me Veronica.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb21.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 1f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 1f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark43.png");
						var flesh = ModAPI.LoadTexture("t/Mark43.png");
						var bone = ModAPI.LoadTexture("t/Mark43.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 42 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "JARVIS, do me a favor and blow Mark 42.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb23.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 1f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 1f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark42.png");
						var flesh = ModAPI.LoadTexture("t/Mark42.png");
						var bone = ModAPI.LoadTexture("t/Mark42.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 41 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Give me that Suitcase!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb22.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/suitarc.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark41.png");
						var flesh = ModAPI.LoadTexture("t/Mark41.png");
						var bone = ModAPI.LoadTexture("t/Mark41.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 44 [ HULKBUSTER ] (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Calm down banner,", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb24.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
									var foot1 = Instance.transform.Find("FrontLeg").Find("FootFront");
									var foot2 = Instance.transform.Find("BackLeg").Find("Foot");
						
						
						
						
						
						
						
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Mark44/Mark44Head.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite.sortingLayerName = "Foreground";




									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("t/Mark44/Mark44Eyelight.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite1.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite1.sortingLayerName = "Foreground";















            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark44/Mark44Upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									upperbigtimeprite.sortingLayerName = "Foreground";		



									GameObject upperbigtime1 = new GameObject();
            						upperbigtime1.transform.parent = upper;
            						upperbigtime1.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime1.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite1 = upperbigtime1.AddComponent<SpriteRenderer>();

            						upperbigtimeprite1.sprite = ModAPI.LoadSprite("t/Mark44/Mark44ARC.png");
            						upperbigtimeprite1.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite1.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite1.sortingLayerName = "Foreground";	







									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Mark44/Mark44Middle.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									middlebigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Mark44/Mark44UpperLeg.png");
									legsprite1.material = ModAPI.FindMaterial("Sprites-Default");
									legsprite1.color = new Color(1f, 1f, 1f, 1f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Mark44/Mark44LowerLeg.png");
									legsprite2.sortingLayerName = "Foreground";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Mark44/Mark44UpperLeg.png");
									legsprite3.material = ModAPI.FindMaterial("Sprites-Default");
									legsprite3.color = new Color(1f, 1f, 1f, 1f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Mark44/Mark44LowerLeg.png");
									legsprite4.sortingLayerName = "Bubbles";
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Mark44/Mark44UpperArm.png");
									armsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Mark44/Mark44UpperArm.png");
									armsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Mark44/Mark44LowerArm.png");
									handsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Mark44/Mark44LowerArm.png");
									handsprite2.sortingLayerName = "Background";
									
									
									GameObject foots1 = new GameObject();
									foots1.transform.parent = foot1;
									foots1.transform.localPosition = new Vector4(0f, 0f);
									foots1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var footsprite1 = foots1.AddComponent<SpriteRenderer>();
									
									footsprite1.sprite = ModAPI.LoadSprite("t/Mark44/Mark44Foot.png");
									footsprite1.sortingLayerName = "Background";
									
									
									
									
									GameObject foots2 = new GameObject();
									foots2.transform.parent = foot2;
									foots2.transform.localPosition = new Vector4(0f, 0f);
									foots2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var footsprite2 = foots2.AddComponent<SpriteRenderer>();
									
									footsprite2.sprite = ModAPI.LoadSprite("t/Mark44/Mark44Foot.png");
									footsprite2.sortingLayerName = "Bubbles";
									
									
            					
									
									GameObject legs41 = new GameObject();
									legs41.transform.parent = leg4;
									legs41.transform.localPosition = new Vector4(0f, 0f);
									legs41.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite41 = legs41.AddComponent<SpriteRenderer>();

									legsprite41.sprite = ModAPI.LoadSprite("t/Mark44/Mark44LegARC.png");
									legsprite41.sortingLayerName = "Foreground";
									legsprite41.color = new Color(0f, 0.65f, 1f, 0.25f);
									legsprite41.material = ModAPI.FindMaterial("VeryBright");		
									
									
									
									
									
									
									
									
									GameObject legs21 = new GameObject();
									legs21.transform.parent = leg2;
									legs21.transform.localPosition = new Vector4(0f, 0f);
									legs21.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite21 = legs21.AddComponent<SpriteRenderer>();

									legsprite21.sprite = ModAPI.LoadSprite("t/Mark44/Mark44LegARC.png");
									legsprite21.sortingLayerName = "Foreground";
									legsprite21.color = new Color(0f, 0.65f, 1f, 0.25f);
									legsprite21.material = ModAPI.FindMaterial("VeryBright");	
									
									
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark44/Mark44Lower.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									upper.gameObject.AddComponent<HeartbreakerUni>();
									
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 1.0205f;
										body.BaseStrength *= 5f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 1.0f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 8000f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().ImpactStrength = 5f;
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark44/Mark44.png");
						var flesh = ModAPI.LoadTexture("t/Mark44/Mark44.png");
						var bone = ModAPI.LoadTexture("t/Mark44/Mark44.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			{
//			ModAPI.Register(
//				new Modification()
//				{
//					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
//					NameOverride = "War Machine MK 1", //new item name with a suffix to assure it is globally unique
//					DescriptionOverride = "Hammer tech?", //new item description
//					CategoryOverride = ModAPI.FindCategory("DUMP_WARMACHINE"), //new item category
//					ThumbnailOverride = ModAPI.LoadSprite("Thumb25.png"), //new item thumbnail (relative path)
//					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
//					{   		
//									var person = Instance.GetComponent<PersonBehaviour>();
//									
//									var head = Instance.transform.Find("Head");
//									var upper = Instance.transform.Find("Body").Find("UpperBody");
//									var middle = Instance.transform.Find("Body").Find("MiddleBody");
//									var lower = Instance.transform.Find("Body").Find("LowerBody");
//									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
//									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
//									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
//									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
//									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
//									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
//									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
//									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
//						
//									GameObject Eyebigtime = new GameObject();
//           						Eyebigtime.transform.parent = head;
//           						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
//            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

//            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();
//
//           						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1Head.png");
//									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
//            						eyebigtimeSprite.color = new Color(1f, 0f, 0f, 0.25f);
//            						eyebigtimeSprite.sortingLayerName = "Bubbles";
//
//            						GameObject upperbigtime = new GameObject();
//            						upperbigtime.transform.parent = upper;
//            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
//            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);
//
//          						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();
//
//           						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1ARC.png");
//            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
//									upperbigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
//									upperbigtimeprite.sortingLayerName = "Bubbles";		
//



//									GameObject upperbigtime1 = new GameObject();
//           						upperbigtime1.transform.parent = upper;
//            						upperbigtime1.transform.localPosition = new Vector4(0f, 0f);
//            						upperbigtime1.transform.localScale = new Vector4(0.5f, 0.5f);

//           						var upperbigtimeprite1 = upperbigtime1.AddComponent<SpriteRenderer>();

//            						upperbigtimeprite1.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1Upper.png");
//            						upperbigtimeprite1.material = ModAPI.FindMaterial("Sprites-Default");
//									upperbigtimeprite1.color = new Color(1f, 1f, 1f, 1f);
//									upperbigtimeprite1.sortingLayerName = "Foreground";	






//									GameObject middlebigtime = new GameObject();
//									middlebigtime.transform.parent = middle;
//									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
//									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

//									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

//									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
//									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
//									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
//									middlebigtimeprite.sortingLayerName = "Foreground";		
//																	

									
//									GameObject legs1 = new GameObject();
//									legs1.transform.parent = leg1;
//									legs1.transform.localPosition = new Vector4(0f, 0f);
//									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
//									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

//									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
//									legsprite1.material = ModAPI.FindMaterial("VeryBright");
//									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
//									legsprite1.sortingLayerName = "Bubbles";
									
									
//									GameObject legs2 = new GameObject();
//									legs2.transform.parent = leg2;
//									legs2.transform.localPosition = new Vector4(0f, 0f);
//									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
//									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

//									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
//									legsprite2.sortingLayerName = "Bubbles";
									
									
									
//									GameObject legs3 = new GameObject();
//									legs3.transform.parent = leg3;
//   								legs3.transform.localPosition = new Vector4(0f, 0f);
//									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
//									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

//									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
//									legsprite3.material = ModAPI.FindMaterial("VeryBright");
//									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
//									legsprite3.sortingLayerName = "Bubbles";
									
									
//									GameObject legs4 = new GameObject();
//									legs4.transform.parent = leg4;
//									legs4.transform.localPosition = new Vector4(0f, 0f);
//									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
//									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

//									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
//									legsprite4.sortingLayerName = "Foreground";
									
									
									
//									GameObject arms1 = new GameObject();
//									arms1.transform.parent = arm1;
//									arms1.transform.localPosition = new Vector4(0f, 0f);
//									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
//									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
//									armsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
//									armsprite1.sortingLayerName = "Bubbles";
									
									
									
									
//									GameObject arms2 = new GameObject();
//									arms2.transform.parent = arm2;
//									arms2.transform.localPosition = new Vector4(0f, 0f);
//									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
//									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
//									armsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
//									armsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
//									GameObject hands1 = new GameObject();
//									hands1.transform.parent = hand1;
//									hands1.transform.localPosition = new Vector4(0f, 0f);
//									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
//									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
//									handsprite1.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1Arm.png");
//									handsprite1.sortingLayerName = "Bubbles";
									
									
									
									
//									GameObject hands2 = new GameObject();
//									hands2.transform.parent = hand2;
//									hands2.transform.localPosition = new Vector4(0f, 0f);
//									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
//									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
//									handsprite2.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1Arm.png");
//									handsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									
									
//									GameObject lowerbigtime = new GameObject();
//									lowerbigtime.transform.parent = lower;
//									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
//									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

//									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

//									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/WarMachine/Transparent.png");
//									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
//									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
//									lowerbigtimeprite.sortingLayerName = "Bubbles";	
//									
//									
//									hand1.gameObject.AddComponent<BarretBehaviour>();
//									hand2.gameObject.AddComponent<BarretBehaviour>(); 
//									 
//									upper.gameObject.AddComponent<warmachineuni>();
									
									
									

//									foreach (var body in person.Limbs)
//									{
//										body.transform.root.localScale *= 0.9975f;
//										body.BaseStrength *= 2f;
//										body.gameObject.AddComponent<Regen>();
//										body.Health += 100f;
//										body.InitialHealth += 100f;
//										body.ShotDamageMultiplier *= 0f;
//										body.Vitality *= 4.5f;
//										body.ImpactPainMultiplier *= 0f;
//										body.Numbness *= 2f;
//										body.IsLethalToBreak = false;
//										body.BreakingThreshold += 55f;
//										body.RegenerationSpeed += 5f;
//										body.CirculationBehaviour.BloodFlow *= 4f;
//										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
//										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
//										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
//										body.PhysicalBehaviour.ConductOverride = true;
//										body.PhysicalBehaviour.ForceNoCharge = true;
//										
//									}
//												
//									//load textures for each layer (see Human textures folder in this repository)
//						var skin = ModAPI.LoadTexture("t/WarMachine/Mark1.png");
//						var flesh = ModAPI.LoadTexture("t/WarMachine/Mark1.png");
//						var bone = ModAPI.LoadTexture("t/WarMachine/Mark1.png");
//			
//						//get person
//						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
//					}
//				}
//			);
			}
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 18 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "CASSANOVA, Protect HEARTBREAKER right now!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb26.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 1f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/18 29 ARC.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 1f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark18.png");
						var flesh = ModAPI.LoadTexture("t/Mark18.png");
						var bone = ModAPI.LoadTexture("t/Mark18.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 29 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "JARVIS, send me some suit.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb27.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 1f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/18 29 ARC.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 1f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/29UpperArm.png");
									armsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/29LowerArm.png");
									handsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark18.png");
						var flesh = ModAPI.LoadTexture("t/Mark18.png");
						var bone = ModAPI.LoadTexture("t/Mark18.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 32 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Romeo and... wait. Where is juliet?", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb28.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 1f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/18 29 ARC.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 1f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark32.png");
						var flesh = ModAPI.LoadTexture("t/Mark32.png");
						var bone = ModAPI.LoadTexture("t/Mark32.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 85 'ENDGAME' (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "And I... am... Ironman. *snaps*", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb29.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Mark85Finale/Mark85FinaleHead.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 0f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("t/Mark85Finale/Mark85FinaleHair.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite1.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite1.sortingLayerName = "Bubbles";
									
									
									

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85Finale/Mark85FinaleUpper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85Finale/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/t1.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/t1.png");
									legsprite4.sortingLayerName = "Foreground";
									legsprite4.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Mark85Finale/Mark85FinaleUpperArm.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/t.png");
									armsprite2.sortingLayerName = "Default";
									armsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands = new GameObject();
									hands.transform.parent = hand1;
									hands.transform.localPosition = new Vector4(0f, 0f);
									hands.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite = hands.AddComponent<SpriteRenderer>();
									
									handsprite.sprite = ModAPI.LoadSprite("t/Mark85Finale/Mark85InfinityGauntlet.png");
									handsprite.sortingLayerName = "Bubbles";
									handsprite.color = new Color(1f, 1f, 1f, 1f);
									handsprite.material = ModAPI.FindMaterial("Sprites-Default");
									
									
								
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Mark85Finale/Mark85InfinityGauntletLight.png");
									handsprite1.sortingLayerName = "Decals";
									handsprite1.color = new Color(1f, 1f, 1f, 0.5f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand1;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Mark85Finale/Mark85FinaleLight.png");
									handsprite2.sortingLayerName = "Decals";
									handsprite2.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/t1.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									AudioClip Gauntlet = ModAPI.LoadSound("t/Mark85Finale/Gauntlet.mp3");
									 
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(217, 0, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(217, 0, 255);

												ModAPI.CreateParticleEffect("Vapor", new Vector2(arm1.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Gauntlet);
											};
										}
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArm")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									}	
									
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark85Finale/Mark85Finale.png");
						var flesh = ModAPI.LoadTexture("t/2.png");
						var bone = ModAPI.LoadTexture("t/3.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Superior Iron Man[Unmasked] (Issue: Superior Iron Man 2014)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "I'm the most intelligent, capable person on the planet. I'm not playing God - all this time... I've been playing human.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb30.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Superior/head.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("t/Superior/hair.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite1.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite1.sortingLayerName = "Bubbles";
									
									
									

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/Superior/upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Superior/middle.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 1f, 1f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Superior/upperleg.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 1f, 1f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Superior/lowerleg.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(1f, 1f, 1f, 0.25f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Superior/upperleg.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 1f, 1f, 0.25f);
									legsprite3.sortingLayerName = "Default";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Superior/lowerleg.png");
									legsprite4.sortingLayerName = "Default";
									legsprite4.color = new Color(1f, 1f, 1f, 0.25f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Superior/upperarm.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Superior/upperarm.png");
									armsprite2.sortingLayerName = "Background";
									armsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands = new GameObject();
									hands.transform.parent = hand1;
									hands.transform.localPosition = new Vector4(0f, 0f);
									hands.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite = hands.AddComponent<SpriteRenderer>();
									
									handsprite.sprite = ModAPI.LoadSprite("t/Superior/lowerarm.png");
									handsprite.sortingLayerName = "Bubbles";
									handsprite.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite.material = ModAPI.FindMaterial("VeryBright");
									
									
								
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand2;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Superior/lowerarm.png");
									handsprite1.sortingLayerName = "Background";
									handsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Superior/lower.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									 
									head.gameObject.AddComponent<HeartbreakerUni>();
									upper.gameObject.AddComponent<HVSPUni>();
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand1.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArm")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand2.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Superior/stark.png");
						var flesh = ModAPI.LoadTexture("t/Superior/stark.png");
						var bone = ModAPI.LoadTexture("t/Superior/stark.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
						
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Iron Man (Marvel's Avengers Video Game)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Good Isn't A Thing You Are, It's A Thing You Do", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb31.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/MarvelAvengersEye.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Default";




            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/MarvelAvengersUpper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									upperbigtimeprite.sortingLayerName = "Foreground";		




									GameObject upperbigtime1 = new GameObject();
            						upperbigtime1.transform.parent = upper;
            						upperbigtime1.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime1.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite1 = upperbigtime1.AddComponent<SpriteRenderer>();

            						upperbigtimeprite1.sprite = ModAPI.LoadSprite("t/MarvelAvengersARC.png");
            						upperbigtimeprite1.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite1.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite1.sortingLayerName = "Default";	








									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/MarvelAvengersMiddle.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									middlebigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/MarvelAvengersSuit.png");
						var flesh = ModAPI.LoadTexture("t/MarvelAvengersSuit.png");
						var bone = ModAPI.LoadTexture("t/MarvelAvengersSuit.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Nano Gauntlet",
                    DescriptionOverride = "Property of Stark Industries / Guardians of the Galaxy",
                    CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb32.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
						Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("t/Gauntlet.png" ,2.8f);

						var childObject = new GameObject("eye");
						childObject.transform.SetParent(Instance.transform);
						childObject.transform.localPosition = new Vector3(0f, 0f);
						childObject.transform.localScale = new Vector3(1f, 1f);
						var childSprite = childObject.AddComponent<SpriteRenderer>();
						childSprite.sprite = ModAPI.LoadSprite("t/GauntletLight.png" ,2.8f);
						childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						childObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

						childSprite.color = new Color(1f, 1f, 1f, 0.05f);


						Instance.FixColliders();

                    }
                }
            );
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Superior Iron Man[Masked] (Issue: Superior Iron Man 2014)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "I'm the most intelligent, capable person on the planet. I'm not playing God - all this time... I've been playing human.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb33.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Superior/head2.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("t/Superior/Transparent.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite1.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite1.sortingLayerName = "Bubbles";
									
									
									

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/Superior/upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Superior/middle.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 1f, 1f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Superior/upperleg.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 1f, 1f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Superior/lowerleg.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(1f, 1f, 1f, 0.25f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Superior/upperleg.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 1f, 1f, 0.25f);
									legsprite3.sortingLayerName = "Default";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Superior/lowerleg.png");
									legsprite4.sortingLayerName = "Default";
									legsprite4.color = new Color(1f, 1f, 1f, 0.25f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Superior/upperarm.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Superior/upperarm.png");
									armsprite2.sortingLayerName = "Background";
									armsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands = new GameObject();
									hands.transform.parent = hand1;
									hands.transform.localPosition = new Vector4(0f, 0f);
									hands.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite = hands.AddComponent<SpriteRenderer>();
									
									handsprite.sprite = ModAPI.LoadSprite("t/Superior/lowerarm.png");
									handsprite.sortingLayerName = "Bubbles";
									handsprite.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite.material = ModAPI.FindMaterial("VeryBright");
									
									
								
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand2;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Superior/lowerarm.png");
									handsprite1.sortingLayerName = "Background";
									handsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Superior/lower.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									 
									head.gameObject.AddComponent<HeartbreakerUni>();
									upper.gameObject.AddComponent<HVSPUni>();
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand1.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArm")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand2.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Superior/SuperiorMasked.png");
						var flesh = ModAPI.LoadTexture("t/Superior/SuperiorMasked.png");
						var bone = ModAPI.LoadTexture("t/Superior/SuperiorMasked.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
						
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 85 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Yes...Probably.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb34.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite1.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite1.sortingLayerName = "Bubbles";
									
									
									

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/transpaernt.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/t1.png");
									legsprite4.sortingLayerName = "Foreground";
									legsprite4.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/t.png");
									armsprite2.sortingLayerName = "Default";
									armsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands = new GameObject();
									hands.transform.parent = hand1;
									hands.transform.localPosition = new Vector4(0f, 0f);
									hands.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite = hands.AddComponent<SpriteRenderer>();
									
									handsprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite.sortingLayerName = "Bubbles";
									handsprite.color = new Color(1f, 1f, 1f, 1f);
									handsprite.material = ModAPI.FindMaterial("Sprites-Default");
									
									
								
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite1.sortingLayerName = "Decals";
									handsprite1.color = new Color(1f, 1f, 1f, 0.5f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand1;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite2.sortingLayerName = "Decals";
									handsprite2.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Lower1.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									upper.gameObject.AddComponent<HVSPUni>(); 
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArm")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									}	
									
									
									
									
									
									
									
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark85/Mark85.png");
						var flesh = ModAPI.LoadTexture("t/Mark85/Mark85.png");
						var bone = ModAPI.LoadTexture("t/Mark85/Mark85.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 85[Handcannon with Backup] (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "I love you 3000.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb35.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite1.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite1.sortingLayerName = "Bubbles";
									
									
									

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		
									
									
									
									
									GameObject upperbigtime1 = new GameObject();
            						upperbigtime1.transform.parent = upper;
            						upperbigtime1.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime1.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite1 = upperbigtime1.AddComponent<SpriteRenderer>();

            						upperbigtimeprite1.sprite = ModAPI.LoadSprite("t/Mark85/HandcannonBack.png");
            						upperbigtimeprite1.material = ModAPI.FindMaterial("Sprites-Default");
									upperbigtimeprite1.color = new Color(1f, 1f, 1f, 1f);
									upperbigtimeprite1.sortingLayerName = "Foreground";	
									
									
									
									
									GameObject upperbigtime2 = new GameObject();
            						upperbigtime2.transform.parent = upper;
            						upperbigtime2.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime2.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite2 = upperbigtime2.AddComponent<SpriteRenderer>();

            						upperbigtimeprite2.sprite = ModAPI.LoadSprite("t/Mark85/HandcannonBackLight.png");
            						upperbigtimeprite2.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite2.color = new Color(1f, 1f, 1f, 0.025f);
									upperbigtimeprite2.sortingLayerName = "Foreground";	
									
									
									
									
									
									
									
									
									
									

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/transpaernt.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/t1.png");
									legsprite4.sortingLayerName = "Foreground";
									legsprite4.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/t.png");
									armsprite2.sortingLayerName = "Default";
									armsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands = new GameObject();
									hands.transform.parent = hand1;
									hands.transform.localPosition = new Vector4(0f, 0f);
									hands.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite = hands.AddComponent<SpriteRenderer>();
									
									handsprite.sprite = ModAPI.LoadSprite("t/Handcannon.png");
									handsprite.sortingLayerName = "Bubbles";
									handsprite.color = new Color(1f, 1f, 1f, 1f);
									handsprite.material = ModAPI.FindMaterial("Sprites-Default");
									
									
								
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/HandcannonLight.png");
									handsprite1.sortingLayerName = "Bubbles";
									handsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Handcannon.png");
									handsprite2.sortingLayerName = "Default";
									handsprite2.color = new Color(1f, 1f, 1f, 1f);
									handsprite2.material = ModAPI.FindMaterial("Sprites-Default");
									
									
									GameObject hands3 = new GameObject();
									hands3.transform.parent = hand2;
									hands3.transform.localPosition = new Vector4(0f, 0f);
									hands3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite3 = hands3.AddComponent<SpriteRenderer>();
									
									handsprite3.sprite = ModAPI.LoadSprite("t/HandcannonLight.png");
									handsprite3.sortingLayerName = "Default";
									handsprite3.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite3.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Lower1.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									upper.gameObject.AddComponent<HVSPUni>(); 
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArm")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand2.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand2.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									}	
									
									
									
									
									
									
									
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark85/Mark85.png");
						var flesh = ModAPI.LoadTexture("t/Mark85/Mark85.png");
						var bone = ModAPI.LoadTexture("t/Mark85/Mark85.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 85[Handcannon] (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "We are in endgame now.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb36.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite1.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite1.sortingLayerName = "Bubbles";
									
									
									

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		
									
									
									
									
									
									
									
									
									
										
									
									
									
									
									
									
									
									
									
									

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/transpaernt.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/t1.png");
									legsprite4.sortingLayerName = "Foreground";
									legsprite4.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/t.png");
									armsprite2.sortingLayerName = "Default";
									armsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands = new GameObject();
									hands.transform.parent = hand1;
									hands.transform.localPosition = new Vector4(0f, 0f);
									hands.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite = hands.AddComponent<SpriteRenderer>();
									
									handsprite.sprite = ModAPI.LoadSprite("t/Handcannon.png");
									handsprite.sortingLayerName = "Bubbles";
									handsprite.color = new Color(1f, 1f, 1f, 1f);
									handsprite.material = ModAPI.FindMaterial("Sprites-Default");
									
									
								
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/HandcannonLight.png");
									handsprite1.sortingLayerName = "Bubbles";
									handsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Handcannon.png");
									handsprite2.sortingLayerName = "Default";
									handsprite2.color = new Color(1f, 1f, 1f, 1f);
									handsprite2.material = ModAPI.FindMaterial("Sprites-Default");
									
									
									GameObject hands3 = new GameObject();
									hands3.transform.parent = hand2;
									hands3.transform.localPosition = new Vector4(0f, 0f);
									hands3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite3 = hands3.AddComponent<SpriteRenderer>();
									
									handsprite3.sprite = ModAPI.LoadSprite("t/HandcannonLight.png");
									handsprite3.sortingLayerName = "Default";
									handsprite3.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite3.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Lower1.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									upper.gameObject.AddComponent<HVSPUni>(); 
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArm")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand2.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand2.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									}		
									
									
									
									
									
									
									
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark85/Mark85.png");
						var flesh = ModAPI.LoadTexture("t/Mark85/Mark85.png");
						var bone = ModAPI.LoadTexture("t/Mark85/Mark85.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 85[Wing] (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "It's not about how much we lost. It's about how much we have left. We're the Avengers. We gotta finish this.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb37.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite1.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite1.sortingLayerName = "Bubbles";
									
									
									

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		
									
									
									
									
									GameObject upperbigtime1 = new GameObject();
            						upperbigtime1.transform.parent = upper;
            						upperbigtime1.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime1.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite1 = upperbigtime1.AddComponent<SpriteRenderer>();

            						upperbigtimeprite1.sprite = ModAPI.LoadSprite("t/Mark85/WingLight.png");
            						upperbigtimeprite1.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite1.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite1.sortingLayerName = "Foreground";	
									
									
									
									
										
									GameObject upperbigtime2 = new GameObject();
            						upperbigtime2.transform.parent = upper;
            						upperbigtime2.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime2.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite2 = upperbigtime2.AddComponent<SpriteRenderer>();

            						upperbigtimeprite2.sprite = ModAPI.LoadSprite("t/Mark85/Wing.png");
            						upperbigtimeprite2.material = ModAPI.FindMaterial("Sprites-Default");
									upperbigtimeprite2.color = new Color(1f, 1f, 1f, 1f);
									upperbigtimeprite2.sortingLayerName = "Foreground";	
									
									
									
									
									
									
									
									
									

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/transpaernt.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/t1.png");
									legsprite4.sortingLayerName = "Foreground";
									legsprite4.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/t.png");
									armsprite2.sortingLayerName = "Default";
									armsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands = new GameObject();
									hands.transform.parent = hand1;
									hands.transform.localPosition = new Vector4(0f, 0f);
									hands.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite = hands.AddComponent<SpriteRenderer>();
									
									handsprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite.sortingLayerName = "Bubbles";
									handsprite.color = new Color(1f, 1f, 1f, 1f);
									handsprite.material = ModAPI.FindMaterial("Sprites-Default");
									
									
								
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite1.sortingLayerName = "Bubbles";
									handsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite2.sortingLayerName = "Default";
									handsprite2.color = new Color(1f, 1f, 1f, 1f);
									handsprite2.material = ModAPI.FindMaterial("Sprites-Default");
									
									
									GameObject hands3 = new GameObject();
									hands3.transform.parent = hand2;
									hands3.transform.localPosition = new Vector4(0f, 0f);
									hands3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite3 = hands3.AddComponent<SpriteRenderer>();
									
									handsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite3.sortingLayerName = "Default";
									handsprite3.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite3.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark85/Mark85Lower1.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									upper.gameObject.AddComponent<HVSPUni>(); 
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArm")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									}	
									
									
									
									
									
									
									
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark85/Mark85.png");
						var flesh = ModAPI.LoadTexture("t/Mark85/Mark85.png");
						var bone = ModAPI.LoadTexture("t/Mark85/Mark85.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor Model 1 (Marvel Comics)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Have you never seen an Iron Man before?!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb39.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Comics/Model1.png");
						var flesh = ModAPI.LoadTexture("t/Comics/Model1.png");
						var bone = ModAPI.LoadTexture("t/Comics/Model1.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor Model 1 Mark III (Marvel Comics)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "That's the name of a top red general, noted for his brutality! He controls this vast commie spy network, and heaven help the undercover man who flubs an assignment!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb40.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Comics/Model1-2.png");
						var flesh = ModAPI.LoadTexture("t/Comics/Model1-2.png");
						var bone = ModAPI.LoadTexture("t/Comics/Model1-2.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor Model 2 (Marvel Comics)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "What do I do now? Iron Man is helpless against an enemy with the ability to melt iron! And yet, without my other identity, I'm just an ordinary human... More vulnerable than most because my heart would stop without my chest plate! (...) What's the matter with me? I'm still not helpless! I've still got the greatest weapon in the world... a human brain!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb41.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Comics/Model2.png");
						var flesh = ModAPI.LoadTexture("t/Comics/Model2.png");
						var bone = ModAPI.LoadTexture("t/Comics/Model2.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor Model 3 (Marvel Comics)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Pepper and Happy, bless their hearts, were probably looking after things for me at the plant during my absence... And knowing them, someone could have stolen the whole factory from under their noses while they argue about which of them is my most alert assistant!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb42.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Comics/Model3.png");
						var flesh = ModAPI.LoadTexture("t/Comics/Model3.png");
						var bone = ModAPI.LoadTexture("t/Comics/Model3.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor Model 4 (Marvel Comics)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Poor Vanko! He sacrificed his life to prove his loyalty to our nation! He shall never be forgotten!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb43.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Comics/Model4.png");
						var flesh = ModAPI.LoadTexture("t/Comics/Model4.png");
						var bone = ModAPI.LoadTexture("t/Comics/Model4.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor Model 5 (Marvel Comics)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "If I know my women, and nobody knows them better than Tony Stark, the Black Widow must be impatient to strike by now! And whatever she does... She'll find Iron Man ready for her this time!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb44.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Comics/Model5.png");
						var flesh = ModAPI.LoadTexture("t/Comics/Model5.png");
						var bone = ModAPI.LoadTexture("t/Comics/Model5.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 50 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "My only curse is you.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb45.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Mark50/Mark50Eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite1.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite1.sortingLayerName = "Bubbles";
									
									
									

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark50/Upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Mark50/Trnasparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Mark50/UpperLeg.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/transpaernt.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Mark50/UpperLeg.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 1f, 1f, 0.05f);
									legsprite3.sortingLayerName = "Default";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/t1.png");
									legsprite4.sortingLayerName = "Foreground";
									legsprite4.color = new Color(1f, 1f, 1f, 0.05f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Mark50/UpperArm.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Mark50/UpperArm.png");
									armsprite2.sortingLayerName = "Default";
									armsprite2.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands = new GameObject();
									hands.transform.parent = hand1;
									hands.transform.localPosition = new Vector4(0f, 0f);
									hands.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite = hands.AddComponent<SpriteRenderer>();
									
									handsprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite.sortingLayerName = "Bubbles";
									handsprite.color = new Color(1f, 1f, 1f, 1f);
									handsprite.material = ModAPI.FindMaterial("Sprites-Default");
									
									
								
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite1.sortingLayerName = "Decals";
									handsprite1.color = new Color(1f, 1f, 1f, 0.5f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand1;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite2.sortingLayerName = "Decals";
									handsprite2.color = new Color(1f, 1f, 1f, 0.05f);
									handsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark50/Lower.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									upper.gameObject.AddComponent<HVSPUni>(); 
									
									
									
									
									
									
									
									
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArm")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									}	
									
									
									
									
									
									
									
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark50/Mark50.png");
						var flesh = ModAPI.LoadTexture("t/Mark50/Mark50.png");
						var bone = ModAPI.LoadTexture("t/Mark50/Mark50.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 50[Handcannon] (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Oh, nano-tech. did you like it?", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb46.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Mark50/Mark50Eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite1.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite1.sortingLayerName = "Bubbles";
									
									
									

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark50/Upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Mark50/Trnasparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Mark50/UpperLeg.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/transpaernt.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Mark50/UpperLeg.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 1f, 1f, 0.05f);
									legsprite3.sortingLayerName = "Default";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/t1.png");
									legsprite4.sortingLayerName = "Foreground";
									legsprite4.color = new Color(1f, 1f, 1f, 0.05f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Mark50/UpperArm.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Mark50/UpperArm.png");
									armsprite2.sortingLayerName = "Default";
									armsprite2.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands = new GameObject();
									hands.transform.parent = hand1;
									hands.transform.localPosition = new Vector4(0f, 0f);
									hands.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite = hands.AddComponent<SpriteRenderer>();
									
									handsprite.sprite = ModAPI.LoadSprite("t/Mark50/Handcannon.png");
									handsprite.sortingLayerName = "Bubbles";
									handsprite.color = new Color(1f, 1f, 1f, 1f);
									handsprite.material = ModAPI.FindMaterial("Sprites-Default");
									
									
								
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Mark50/HandcannonLight.png");
									handsprite1.sortingLayerName = "Decals";
									handsprite1.color = new Color(1f, 1f, 1f, 0.5f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Mark50/HandcannonLight.png");
									handsprite2.sortingLayerName = "Default";
									handsprite2.color = new Color(1f, 1f, 1f, 0.5f);
									handsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands3 = new GameObject();
									hands3.transform.parent = hand2;
									hands3.transform.localPosition = new Vector4(0f, 0f);
									hands3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite3 = hands3.AddComponent<SpriteRenderer>();
									
									handsprite3.sprite = ModAPI.LoadSprite("t/Mark50/Handcannon.png");
									handsprite3.sortingLayerName = "Default";
									handsprite3.color = new Color(1f, 1f, 1f, 1f);
									handsprite3.material = ModAPI.FindMaterial("Sprites-Default");
									
									
									
									
									
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark50/Lower.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									upper.gameObject.AddComponent<HVSPUni>(); 
									
									
									
									
									
									
									
									
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
									
									
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArm")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand2.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand2.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									}	
									
									
									
									
									
									
									
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark50/Mark50.png");
						var flesh = ModAPI.LoadTexture("t/Mark50/Mark50.png");
						var bone = ModAPI.LoadTexture("t/Mark50/Mark50.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 50[Handcannon with Backup] (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Okay, that squidward wants wizard.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb47.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Mark50/Mark50Eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite1.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite1.sortingLayerName = "Bubbles";
									
									
									

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark50/Upper.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite.sortingLayerName = "Foreground";	




									GameObject upperbigtime1 = new GameObject();
            						upperbigtime1.transform.parent = upper;
            						upperbigtime1.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime1.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite1 = upperbigtime1.AddComponent<SpriteRenderer>();

            						upperbigtimeprite1.sprite = ModAPI.LoadSprite("t/Mark50/HandcannonBack.png");
            						upperbigtimeprite1.material = ModAPI.FindMaterial("Sprites-Default");
									upperbigtimeprite1.color = new Color(1f, 1f, 1f, 1f);
									upperbigtimeprite1.sortingLayerName = "Foreground";	






									GameObject upperbigtime2 = new GameObject();
            						upperbigtime2.transform.parent = upper;
            						upperbigtime2.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime2.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite2 = upperbigtime2.AddComponent<SpriteRenderer>();

            						upperbigtimeprite2.sprite = ModAPI.LoadSprite("t/Mark50/HandcannonBackLight.png");
            						upperbigtimeprite2.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite2.color = new Color(1f, 1f, 1f, 0.05f);
									upperbigtimeprite2.sortingLayerName = "Foreground";	












									

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Mark50/Trnasparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Mark50/UpperLeg.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/transpaernt.png");
									legsprite2.sortingLayerName = "Bubbles";
									legsprite2.color = new Color(0f, 1f, 1f, 0.05f);
									legsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Mark50/UpperLeg.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 1f, 1f, 0.05f);
									legsprite3.sortingLayerName = "Default";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/t1.png");
									legsprite4.sortingLayerName = "Foreground";
									legsprite4.color = new Color(1f, 1f, 1f, 0.05f);
									legsprite4.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Mark50/UpperArm.png");
									armsprite1.sortingLayerName = "Bubbles";
									armsprite1.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Mark50/UpperArm.png");
									armsprite2.sortingLayerName = "Default";
									armsprite2.color = new Color(1f, 1f, 1f, 0.05f);
									armsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands = new GameObject();
									hands.transform.parent = hand1;
									hands.transform.localPosition = new Vector4(0f, 0f);
									hands.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite = hands.AddComponent<SpriteRenderer>();
									
									handsprite.sprite = ModAPI.LoadSprite("t/Mark50/Handcannon.png");
									handsprite.sortingLayerName = "Bubbles";
									handsprite.color = new Color(1f, 1f, 1f, 1f);
									handsprite.material = ModAPI.FindMaterial("Sprites-Default");
									
									
								
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Mark50/HandcannonLight.png");
									handsprite1.sortingLayerName = "Decals";
									handsprite1.color = new Color(1f, 1f, 1f, 0.5f);
									handsprite1.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Mark50/HandcannonLight.png");
									handsprite2.sortingLayerName = "Default";
									handsprite2.color = new Color(1f, 1f, 1f, 0.5f);
									handsprite2.material = ModAPI.FindMaterial("VeryBright");
									
									
									
									
									GameObject hands3 = new GameObject();
									hands3.transform.parent = hand2;
									hands3.transform.localPosition = new Vector4(0f, 0f);
									hands3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite3 = hands3.AddComponent<SpriteRenderer>();
									
									handsprite3.sprite = ModAPI.LoadSprite("t/Mark50/Handcannon.png");
									handsprite3.sortingLayerName = "Default";
									handsprite3.color = new Color(1f, 1f, 1f, 1f);
									handsprite3.material = ModAPI.FindMaterial("Sprites-Default");
									
									
									
									
									
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Mark50/Lower.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									lowerbigtimeprite.color = new Color(0f, 1f, 1f, 0.05f);
									lowerbigtimeprite.sortingLayerName = "Foreground";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									upper.gameObject.AddComponent<HVSPUni>(); 
									
									
									
									
									
									
									
									
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
									
									
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArm")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand2.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
									
									if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(0, 120, 255);
												HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(0, 120, 255);

												ModAPI.CreateParticleEffect("Flash", new Vector2(hand2.transform.position.x, arm1.transform.position.y + 0.1f));
												HandOBJ2.transform.position = body.gameObject.transform.position;
												HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}	
									}	
									
									
									
									
									
									
									
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark50/Mark50.png");
						var flesh = ModAPI.LoadTexture("t/Mark50/Mark50.png");
						var bone = ModAPI.LoadTexture("t/Mark50/Mark50.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Iron Patriot[Weapon Detached] (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "When You Break Into A Place Called ‘The Temple Of The Power Stone,’ There’s Usually A Bunch Of Booby Traps.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's WarMachine"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb48.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotEyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 0.25f, 0.25f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Foreground";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotARC.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 0.25f, 0.25f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

											
									
									
									var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
									person.SetBodyTextures(ModAPI.LoadTexture("t/WarMachine/Patriot.png"), ModAPI.LoadTexture("t/WarMachine/Patriot.png"), null, 1);
									
									
									person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotHead.png", 2);
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotHead.png"));
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotHead.png"));
									
									
									person.Limbs[1].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotArmor.png", 2);
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotArmor.png"));
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotArmor.png"));
									
									
									person.Limbs[2].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotMiddle.png", 2);
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotMiddle.png"));
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotMiddle.png"));
									
									
									person.Limbs[3].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotLower.png", 2);
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotLower.png"));
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotLower.png"));
									
									
									person.Limbs[4].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotUpperLeg.png", 2);
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperLeg.png"));
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperLeg.png"));
									
									
									person.Limbs[5].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotLowerLeg.png", 2);
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotLowerLeg.png"));
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotLowerLeg.png"));
									
									
									person.Limbs[6].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotUpperFoot.png", 2);
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperFoot.png"));
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperFoot.png"));
									
									
									person.Limbs[7].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotUpperLeg.png", 2);
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperLeg.png"));
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperLeg.png"));
									
									
									person.Limbs[8].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotLowerLeg.png", 2);
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotLowerLeg.png"));
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotLowerLeg.png"));
									
									
									person.Limbs[9].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotUpperFoot.png", 2);
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperFoot.png"));
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperFoot.png"));
									
									
									person.Limbs[10].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotUpperArm.png", 2);
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperArm.png"));
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperArm.png"));
									
									
									person.Limbs[11].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotArm.png", 2);
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotArm.png"));
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotArm.png"));
									
									
									person.Limbs[12].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotUpperArm.png", 2);
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperArm.png"));
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotUpperArm.png"));
									
									
									person.Limbs[13].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotArm.png", 2);
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/PatriotArm.png"));
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/PatriotArm.png"));
									
									 
									
									
									
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
								
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.red;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.red;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
						var skin = ModAPI.LoadTexture("t/WarMachine/Patriot.png");
						var flesh = ModAPI.LoadTexture("t/WarMachine/Patriot.png");
						var bone = ModAPI.LoadTexture("t/WarMachine/Patriot.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "War Machine Mark 2[Weapon Detached] (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "This Lone Gunslinger Act Is Unnecessary. You Don’t Have To Do This Alone!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's WarMachine"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb49.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotEyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 0.65f, 0.65f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Foreground";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/WarMachine/PatriotARC.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 0.65f, 0.65f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

											
									
									
									var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
									person.SetBodyTextures(ModAPI.LoadTexture("t/WarMachine/Patriot.png"), ModAPI.LoadTexture("t/WarMachine/Patriot.png"), null, 1);
									
									
									person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2Head.png", 2);
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2Head.png"));
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2Head.png"));
									
									
									person.Limbs[1].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2Upper.png", 2);
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2Upper.png"));
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2Upper.png"));
									
									
									person.Limbs[2].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2Middle.png", 2);
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2Middle.png"));
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2Middle.png"));
									
									
									person.Limbs[3].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2Lower.png", 2);
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2Lower.png"));
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2Lower.png"));
									
									
									person.Limbs[4].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2UpperLeg.png", 2);
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2UpperLeg.png"));
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2UpperLeg.png"));
									
									
									person.Limbs[5].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2LowerLeg.png", 2);
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2LowerLeg.png"));
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2LowerLeg.png"));
									
									
									person.Limbs[6].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2Foot.png", 2);
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2Foot.png"));
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2Foot.png"));
									
									
									person.Limbs[7].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2UpperLeg.png", 2);
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2UpperLeg.png"));
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2UpperLeg.png"));
									
									
									person.Limbs[8].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2LowerLeg.png", 2);
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2LowerLeg.png"));
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2LowerLeg.png"));
									
									
									person.Limbs[9].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2Foot.png", 2);
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2Foot.png"));
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2Foot.png"));
									
									
									person.Limbs[10].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2UpperArm.png", 2);
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2UpperArm.png"));
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2UpperArm.png"));
									
									
									person.Limbs[11].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2LowerArm.png", 2);
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2LowerArm.png"));
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2LowerArm.png"));
									
									
									person.Limbs[12].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2UpperArm.png", 2);
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2UpperArm.png"));
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2UpperArm.png"));
									
									
									person.Limbs[13].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark2LowerArm.png", 2);
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark2LowerArm.png"));
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark2LowerArm.png"));
									
									 
									
									
									
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
								
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.red;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.red;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
						var skin = ModAPI.LoadTexture("t/WarMachine/Mark2.png");
						var flesh = ModAPI.LoadTexture("t/WarMachine/Mark2.png");
						var bone = ModAPI.LoadTexture("t/WarMachine/Mark2.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "War Machine Mark 1[Weapon Detached] (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "If You Want This Suit, You’re Going To Have To Pry My Cold Dead Body Out Of It.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's WarMachine"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb50.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1Eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 0.65f, 0.65f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Foreground";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1ARC.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 0.65f, 0.65f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

											
									
									
									var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
									person.SetBodyTextures(ModAPI.LoadTexture("t/WarMachine/Patriot.png"), ModAPI.LoadTexture("t/WarMachine/Patriot.png"), null, 1);
									
									
									person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1Head.png", 2);
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1Head.png"));
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1Head.png"));
									
									
									person.Limbs[1].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1Upper.png", 2);
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1Upper.png"));
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1Upper.png"));
									
									
									person.Limbs[2].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1Middle.png", 2);
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1Middle.png"));
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1Middle.png"));
									
									
									person.Limbs[3].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1Lower.png", 2);
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1Lower.png"));
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1Lower.png"));
									
									
									person.Limbs[4].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1UpperLeg.png", 2);
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1UpperLeg.png"));
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1UpperLeg.png"));
									
									
									person.Limbs[5].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1LowerLeg.png", 2);
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1LowerLeg.png"));
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1LowerLeg.png"));
									
									
									person.Limbs[6].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1Foot.png", 2);
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1Foot.png"));
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1Foot.png"));
									
									
									person.Limbs[7].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1UpperLeg.png", 2);
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1UpperLeg.png"));
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1UpperLeg.png"));
									
									
									person.Limbs[8].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1LowerLeg.png", 2);
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1LowerLeg.png"));
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1LowerLeg.png"));
									
									
									person.Limbs[9].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1Foot.png", 2);
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1Foot.png"));
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1Foot.png"));
									
									
									person.Limbs[10].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1UpperArm.png", 2);
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1UpperArm.png"));
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1UpperArm.png"));
									
									
									person.Limbs[11].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1LowerArm.png", 2);
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1LowerArm.png"));
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1LowerArm.png"));
									
									
									person.Limbs[12].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1UpperArm.png", 2);
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1UpperArm.png"));
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1UpperArm.png"));
									
									
									person.Limbs[13].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("t/WarMachine/Mark1LowerArm.png", 2);
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("t/WarMachine/Mark1LowerArm.png"));
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("t/WarMachine/Mark1LowerArm.png"));
									
									 
									
									
									
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
								
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.red;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.red;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
						var skin = ModAPI.LoadTexture("t/WarMachine/Mark1.png");
						var flesh = ModAPI.LoadTexture("t/WarMachine/Mark1.png");
						var bone = ModAPI.LoadTexture("t/WarMachine/Mark1.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor MK 45 (Marvel Cinematic Universe)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "I tried to create a suit of armor around the world, but I created something terrible.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb51.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(0f, 1f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("t/MarvelAvengersARC.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(0f, 1f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									GameObject middlebigtime = new GameObject();
									middlebigtime.transform.parent = middle;
									middlebigtime.transform.localPosition = new Vector4(0f, 0f);
									middlebigtime.transform.localScale = new Vector4(0.5f, 0.5f);

									var middlebigtimeprite = middlebigtime.AddComponent<SpriteRenderer>();

									middlebigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									middlebigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									middlebigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									middlebigtimeprite.sortingLayerName = "Foreground";		
																	

									
									GameObject legs1 = new GameObject();
									legs1.transform.parent = leg1;
									legs1.transform.localPosition = new Vector4(0f, 0f);
									legs1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite1 = legs1.AddComponent<SpriteRenderer>();

									legsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite1.material = ModAPI.FindMaterial("VeryBright");
									legsprite1.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite1.sortingLayerName = "Bubbles";
									
									
									GameObject legs2 = new GameObject();
									legs2.transform.parent = leg2;
									legs2.transform.localPosition = new Vector4(0f, 0f);
									legs2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite2 = legs2.AddComponent<SpriteRenderer>();

									legsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite2.sortingLayerName = "Bubbles";
									
									
									
									GameObject legs3 = new GameObject();
									legs3.transform.parent = leg3;
									legs3.transform.localPosition = new Vector4(0f, 0f);
									legs3.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite3 = legs3.AddComponent<SpriteRenderer>();

									legsprite3.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite3.material = ModAPI.FindMaterial("VeryBright");
									legsprite3.color = new Color(1f, 0f, 0f, 0.25f);
									legsprite3.sortingLayerName = "Bubbles";
									
									
									GameObject legs4 = new GameObject();
									legs4.transform.parent = leg4;
									legs4.transform.localPosition = new Vector4(0f, 0f);
									legs4.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite4 = legs4.AddComponent<SpriteRenderer>();

									legsprite4.sprite = ModAPI.LoadSprite("t/Transparent.png");
									legsprite4.sortingLayerName = "Foreground";
									
									
									
									GameObject arms1 = new GameObject();
									arms1.transform.parent = arm1;
									arms1.transform.localPosition = new Vector4(0f, 0f);
									arms1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite1 = arms1.AddComponent<SpriteRenderer>();
									
									armsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject arms2 = new GameObject();
									arms2.transform.parent = arm2;
									arms2.transform.localPosition = new Vector4(0f, 0f);
									arms2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var armsprite2 = arms2.AddComponent<SpriteRenderer>();
									
									armsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									armsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									GameObject hands1 = new GameObject();
									hands1.transform.parent = hand1;
									hands1.transform.localPosition = new Vector4(0f, 0f);
									hands1.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite1 = hands1.AddComponent<SpriteRenderer>();
									
									handsprite1.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite1.sortingLayerName = "Bubbles";
									
									
									
									
									GameObject hands2 = new GameObject();
									hands2.transform.parent = hand2;
									hands2.transform.localPosition = new Vector4(0f, 0f);
									hands2.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var handsprite2 = hands2.AddComponent<SpriteRenderer>();
									
									handsprite2.sprite = ModAPI.LoadSprite("t/Transparent.png");
									handsprite2.sortingLayerName = "Background";
									
									
									
									
									
									
									
									
									GameObject lowerbigtime = new GameObject();
									lowerbigtime.transform.parent = lower;
									lowerbigtime.transform.localPosition = new Vector4(0f, 0f);
									lowerbigtime.transform.localScale = new Vector4(0.25f, 0.25f);

									var lowerbigtimeprite = lowerbigtime.AddComponent<SpriteRenderer>();

									lowerbigtimeprite.sprite = ModAPI.LoadSprite("t/Transparent.png");
									lowerbigtimeprite.material = ModAPI.FindMaterial("Sprites-Default");
									lowerbigtimeprite.color = new Color(1f, 1f, 1f, 1f);
									lowerbigtimeprite.sortingLayerName = "Bubbles";	
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Mark45.png");
						var flesh = ModAPI.LoadTexture("t/Mark45.png");
						var bone = ModAPI.LoadTexture("t/Mark45.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "Armor Model 6 (Marvel Comics)", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "If I know my women, and nobody knows them better than Tony Stark, the Black Widow must be impatient to strike by now! And whatever she does... She'll find Iron Man ready for her this time!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's IronMan"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb52.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
						
						
						
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.505f, 0.505f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("t/Comics/Model6Head.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("Sprites-Default");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 1f);
            						eyebigtimeSprite.sortingLayerName = "Bubbles";
									
									
									
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									 
									upper.gameObject.AddComponent<Uni>();
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 0.9955f;
										body.BaseStrength *= 2f;
										body.gameObject.AddComponent<Regen>();
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
										
										
										if (body.GetComponent<GripBehaviour>())
											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1500f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
												
									//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("t/Comics/Model6.png");
						var flesh = ModAPI.LoadTexture("t/Comics/Model6.png");
						var bone = ModAPI.LoadTexture("t/Comics/Model6.png");
			
						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
		}
	}
}